#include "../include/partcutdesc_generator.h"

char* cutExceptionList[] = {
         "PHM_10_UB_0002_E.pac",
         "PHW_10_UB_0002_E.pac",
         "PEW_10_UB_0002_E.pac",
         "PGM_10_UB_0002_E.pac",
         "PBW_10_UB_0002_E.pac",
         "PKM_10_UB_0002_E.pac",
         "PVW_10_UB_0002_E.pac",
         "PDW_10_UB_0002_E.pac",
         "PWM_10_UB_0002_E.pac",
         "PKW_10_UB_0002_E.pac",
         "PKWW_10_UB_0002_E.pac",
         "PKW_10_UB_0002_E.pac",
         "PNM_10_UB_0002_E.pac",
         "PWW_10_UB_0002_E.pac",
         "PHW_VW_UB_0003.pac",
         "PVW_00_UB_0003.pac",
         "PDW_00_UB_0003.pac",
         "PKW_00_UB_0001.pac",
         "PKWW_00_UB_0001.pac",
         "PKW_VW_UB_0003.pac",
         "PKWW_VW_UB_0003.pac",
         "PKW_00_LB_0001.pac",
         "PKWW_00_LB_0001.pac",
         "PHW_EW_Hel_0031_HairCut.pac",
         "PWW_EW_Hel_0031_HairCut.pac",
         "PWM_HM_Hel_0031_HairCut.pac",
         "PKW_EW_Hel_0031_HairCut.pac",
         "PKWW_EW_Hel_0031_HairCut.pac",
         "PVW_EW_Hel_0031_HairCut.pac",
         "PBW_EW_Hel_0031_HairCut.pac",
         "PNW_EW_Hel_0031_HairCut.pac",
         "PWM_00_Hel_0034_A.pac",
         "PWM_00_Hel_0072_D.pac",
         "PKM_00_Hel_0072_D.pac",
         "PHM_00_Hel_0072_D.pac",
         "PWM_00_Contribute_Hel_0106.pac",
         "PNM_02_Hel_0001_op.pac",
         "PNM_02_Hel_0002_op.pac",
         "PNM_02_Hel_0003_op.pac",
         "PNM_02_Hel_0004_op.pac",
         "PNM_03_Hel_0001_op.pac",
         "PNM_03_Hel_0002_op.pac",
         "PNM_03_Hel_0003_op.pac",
         "PHW_00_Hair_0014.pac",
         "PHW_00_Hair_0012.pac",
         "PVW_00_Hair_0012.pac",
         "PVW_00_Hair_0014.pac",
         "PKW_00_Hair_0003.pac",
         "PKW_00_Hair_0007.pac",
         "PKW_00_Hair_0016.pac",
         "PWW_00_Hair_0013.pac",
         "PWM_00_Hair_0009.pac",
         "PBW_00_Hair_0013.pac",
         "PNW_00_Hair_0013.pac",
         "PKWW_00_Hair_0001.pac",
         "PKWW_00_Hair_0003.pac",
         "PKWW_00_Hair_0007.pac",
         "PKWW_00_Hair_0016.pac",
         "PHW_00_Sho_0002.pac",
         "PHW_BW_Sho_0017.pac",
         "PHW_VW_Sho_0003.pac",
         "PHW_EW_Sho_0033.pac",
         "PHW_10_Sho_0010.pac",
         "PHW_10_Sho_0010_dm.pac",
         "PHW_00_Sho_0043.pac",
         "PHW_00_Sho_0043_dm.pac",
         "PHW_00_Sho_0049.pac",
         "PHW_00_Sho_0049_dm.pac",
         "PEW_00_Sho_0053.pac",
         "PHW_00_Sho_0077.pac",
         "PHW_10_Sho_0018.pac",
         "PHW_50_Sho_0007.pac",
         "PHW_10_Sho_0020.pac",
         "PHW_10_Sho_0020_01.pac",
         "PHW_10_Sho_0020_01_dm.pac",
         "PHM_00_EVT_0001_E.pac",
         "PHW_00_EVT_0001_E.pac",
         "PEW_00_EVT_0001_E.pac",
         "PGM_00_EVT_0001_E.pac",
         "PGM_00_EVT_0001_Mul_E.pac",
         "PBW_00_EVT_0001_E.pac",
         "PKM_00_EVT_0001_E.pac",
         "PVW_00_EVT_0001_E.pac",
         "PVW_00_EVT_0001_E.pac",
         "PWM_00_EVT_0001_E.pac",
         "PKW_00_EVT_0001_E.pac",
         "PKWW_00_EVT_0001_E.pac",
         "PWW_00_EVT_0001_E.pac",
         "PNW_00_EVT_0001_E.pac",
         "PNM_00_EVT_0001_E.pac",
         "PHM_00_EVT_LB_0001.pac",
         "PHW_00_EVT_LB_0001.pac",
         "PHM_00_EVT_LB_0001.pac",
         "PEW_00_EVT_LB_0001.pac",
         "PGM_00_EVT_LB_0001.pac",
         "PBW_00_EVT_LB_0001.pac",
         "PKM_00_EVT_LB_0001.pac",
         "PVW_00_EVT_LB_0001.pac",
         "PWM_00_EVT_LB_0001.pac",
         "PKW_00_EVT_LB_0001.pac",
         "PKWW_00_EVT_LB_0001.pac",
         "PWW_00_EVT_LB_0001.pac",
         "PNW_00_EVT_LB_0001.pac",
         "PNM_00_EVT_LB_0001.pac",
         "PHW_10_Hand_0003.pac",
         "PHW_10_Hand_0013.pac",
         "PEW_10_Hand_0003.pac",
         "PEW_10_Hand_0013.pac",
         "PNM_00_Hel_0001_op.pac",
         "PNM_00_Hel_0072_D.pac",
         "PHM_99_Hel_0012_D.pac",
         "PHW_99_Hel_0012_D.pac",
         "PEW_99_Hel_0012_D.pac",
         "PGM_99_Hel_0012_D.pac",
         "PBW_99_Hel_0012_D.pac",
         "PKM_99_Hel_0012_D.pac",
         "PVW_99_Hel_0012_D.pac",
         "PWM_99_Hel_0012_D.pac",
         "PWW_99_Hel_0012_D.pac",
         "PNM_99_Hel_0012_D.pac",
         "PNW_99_Hel_0012_D.pac",
         "PKWW_99_Hel_0012_D.pac"
};


void generatePartcutdesc(FileBlock* fileBlocks, MetaFileInfo* metaFileInfo)
{
    //MemFile* missingFileMem = readMissingFiles(metaFileInfo);

    if (!fileBlocks)
    {
        printf("\nFailed to alocate FileBlocks\n");
        system("PAUSE");
        exit(1);
    }

    //int i = metaFileInfo->fileBlocksCount;
    int j = 0;

    /*printf("\nFilling Missing Blocks...");
    for (j = 0; j < metaFileInfo->missingFilesCount; j++)
    {
        if (missingFileMem->bytes == NULL)
        {
            printf("\nWarning: Reached end of the missing_files.txt string unexpectedly\n");
            break;
        }

        fileBlocks[i].offset = -1;
        if (j == 0)
        {
            fileBlocks[i].hash = atoi(strtok(missingFileMem->bytes,"|"));
        }
        else
        {
            fileBlocks[i].hash = atoi(strtok(NULL,"|"));
        }
        fileBlocks[i].folderNum = atoi(strtok(NULL,"|"));
        fileBlocks[i].fileNum = atoi(strtok(NULL,"|"));
        fileBlocks[i].pazName = strtok(NULL,"|");
        fileBlocks[i].folderName = strtok(NULL,"|");
        fileBlocks[i].fileName = strtok(NULL,"\n");
        fileBlocks[i].fileName[strlen(fileBlocks[i].fileName ) - 1] = '\0';
        fileBlocks[i].needPatch = 0;
        metaFileInfo->fileBlocksCount++;

         i++;
    }
     printf("\nDone.\n");*/

    qsort(fileBlocks,metaFileInfo->fileBlocksCount,sizeof(FileBlock),compare);


    printf("\nGenerating partcutdesc.xml file...");
    createPath(concatenate(bdoRootFolder(),"character\\"));
    FILE* partcutdesc = openFile(concatenate(bdoRootFolder(),"character\\partcutdesc.xml"), "wb");

    int classAllowed[13];
    for (j = 0; j < 13; j++)
    {
        classAllowed[j] = 1;
    }

    createCutTypeBlock("Underwear","38_Underwear",classAllowed,partcutdesc,metaFileInfo,fileBlocks);
    createCutTypeBlock("Event","Event_costume",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    classAllowed[PEW] = 0;
    classAllowed[PWM] = 0;
    classAllowed[PWW] = 0;
    classAllowed[PHW] = 0;
    classAllowed[PBW] = 0;
    createCutTypeBlock("Upperbody","9_Upperbody",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < 13; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PEW] = 1;
    classAllowed[PWM] = 1;
    classAllowed[PWW] = 1;
    createCutTypeBlock("PEW_Upperbody","9_Upperbody",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < 13; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PHW] = 1;
    createCutTypeBlock("PHW_Upperbody02","9_Upperbody",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < 13; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PBW] = 1;
    createCutTypeBlock("PBW_Upperbody05","9_Upperbody",classAllowed,partcutdesc,metaFileInfo,fileBlocks);


    for (j = 0; j < 13; j++)
    {
        classAllowed[j] = 1;
    }
    classAllowed[PBW] = 0;
    classAllowed[PWM] = 0;
    classAllowed[PWW] = 0;
    createCutTypeBlock("Hand","11_Hand",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < 13; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PBW] = 1;
    classAllowed[PWM] = 1;
    classAllowed[PWW] = 1;
    createCutTypeBlock("PBW_Hand05","11_Hand",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < 13; j++)
    {
        classAllowed[j] = 1;
    }
    createCutTypeBlock("Lowerbody","10_Lowerbody",classAllowed,partcutdesc,metaFileInfo,fileBlocks);
    createCutTypeBlock("Foot","12_Foot",classAllowed,partcutdesc,metaFileInfo,fileBlocks);
    createCutTypeBlock("Hel","13_Hel",classAllowed,partcutdesc,metaFileInfo,fileBlocks);
    createCutTypeBlock("Hair","Hair",classAllowed,partcutdesc,metaFileInfo,fileBlocks);


    for (j = 0; j < 13; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PHM] = 1;
    classAllowed[PNM] = 1;
    createCutTypeBlock("Sho","14_Sho",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < 13; j++)
    {
        classAllowed[j] = 1;
    }
    createCutTypeBlock("EnchantArm","28_EnchantArm",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < 13; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PHW] = 1;
    createCutTypeBlock("PHW_Sho02","14_Sho",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < 13; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PBW] = 1;
    classAllowed[PEW] = 1;
    classAllowed[PVW] = 1;
    classAllowed[PWW] = 1;
    classAllowed[PKWW] = 1;
    classAllowed[PNW] = 1;
    createCutTypeBlock("PBW_Sho","14_Sho",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    printf("\nDone.\n");

    printf("\nExtracting original partcutdesc file:\n");

    char* command = (char*) malloc (strlen("cd patcher_resources & quickbms.exe -Y -f \"*partcutdesc.xml*\" blackdesert.bms ../PAD00001.PAZ ./") + 1);
    sprintf(command,"cd patcher_resources & quickbms.exe -Y -f \"*partcutdesc.xml*\" blackdesert.bms ../PAD00001.PAZ ./");
    system(command);
    free(command);

    FILE* originalPartCutDesc = openFile("patcher_resources\\character\\partcutdesc.xml", "rb");
    char buffer;
    printf("\n\nMerging original and created partcutdesc.xml files...\n");


    while(fread(&buffer,1,1,originalPartCutDesc))
    {
        fwrite(&buffer,1,1,partcutdesc);
    }

    FileBlock* partCutDescBlock = NULL;

    // Apply patch: partcutdesc.xml
    int i = 0;
    for( i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        if (strcmpi(fileBlocks[i].fileName,"partcutdesc.xml") == 0)
        {
            partCutDescBlock = &fileBlocks[i];
            partCutDescBlock->needPatch = 1;
            patchMetaFile(partCutDescBlock, 1);
        }
    }
    if (partCutDescBlock == NULL)
    {
        printf("\nError: partcutdesc.xml not found in File Blocks\n");
        PAUSE();
    }

    float fileSize = (float)getFileSizeByName(concatenate(bdoRootFolder(),"character\\partcutdesc.xml"));
    fileSize /= 1000.0;

    if (fileSize < 100.0)
    {
        printf("\nSomething went wrong, your partcutdesc.xml file should have at least 100kb and it has %.2f", fileSize);
    }
    else
    {
        printf("\nCompleted! partcutdesc.xml file size: %.2fkb", fileSize);
    }
    fclose(originalPartCutDesc);
    fclose(partcutdesc);
}

void writestr(char* str,FILE* fp)
{
    fwrite(str,strlen(str),1,fp);
}

char* cutTypeOpenTag(char* label)
{
    char* tag = (char*) malloc(256);
    strcpy(tag,"<CutType Name=\"");
    strcat(tag,label);
    strcat(tag,"\">\n");
    return tag;
}

char* basicCutTypeOpenTag(char* label)
{
    char* tag = (char*) malloc(256);
    strcpy(tag,"<BasicCutType Name=\"");
    strcat(tag,label);
    strcat(tag,"\">\n");
    return tag;
}

char* getFileBlockFullPath(FileBlock fileBlock)
{
    return concatenate(substr(fileBlock.folderName,strlen("character/model/"),strlen(fileBlock.folderName)),fileBlock.fileName);
}

int isOnExpectionList(char* name, char** exceptionList, int size)
{
    int i = 0;
    for (i = 0; i < size; i++)
    {
        if (strcmpi(name,exceptionList[i]) == 0)
        {
            return 1;
        }
    }
    return 0;
}


void addToPartCutDesc(FileBlock fileBlock, FILE* partcutdesc)
{
    char* fileOpenTag = "\t<File>";
    char* fileCloseTag = "</File>\n";
    if(/*!isOnExpectionList(fileBlock.fileName,cutExceptionList,121) && */strcmpi(getFileExt(fileBlock.fileName),"pac") == 0)
     {
        writestr(fileOpenTag,partcutdesc);
        writestr(getFileBlockFullPath(fileBlock),partcutdesc);
        writestr(fileCloseTag,partcutdesc);
     }
}
void createCutTypeBlock(char* blockName,char* compareFolderName,int* classAllowed, FILE* partcutdesc, MetaFileInfo* metaFileInfo,FileBlock* fileBlocks)
{
    int i = 0;
    int skip = 0;

    writestr(cutTypeOpenTag(blockName), partcutdesc);
    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        skip = 0;

         if (strcmpi(getLastFolder(fileBlocks[i].folderName),compareFolderName) == 0)
         {
             char* classPrefix = getClassPrefix(fileBlocks[i].fileName);

            if (classAllowed[PHM])
            {
                if (strcmpi(classPrefix,"phm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PHW])
            {
                if (strcmpi(classPrefix,"phw") == 0)
                {
                    PatcherState* patcherState = loadPatcherState(PATCHER_STATE_FILE_NAME);
                    if (patcherState->booleanValues[CLEAD] == ON)
                    {
                            if (strcmpi(fileBlocks[i].fileName, "phw_00_ub_0004.pac") == 0)
                            {
                                printColor("\nSkipped - ", YELLOW);printf("phw_00_ub_0004.pac");
                                skip = 1;
                            }

                        if (patcherState->cleadOption == BERN_SHORTS)
                        {
                            if (strcmpi(fileBlocks[i].fileName, "FILE_NAME.pac") == 0)
                            {
                                skip = 1;
                            }
                            if (strcmpi(fileBlocks[i].fileName, "phw_00_lb_0004.pac") == 0)
                            {
                                printColor("\nSkipped - ", YELLOW);printf("phw_00_LB_0004.pac");
                                skip = 1;
                            }
                        }
                        if (patcherState->cleadOption == DEFAULT_PANTS)
                        {
                            if (strcmpi(fileBlocks[i].fileName, "FILE_NAME") == 0)
                            {
                                skip = 1;
                            }
                        }
                       if (patcherState->cleadOption == NONE)
                        {
                            if (strcmpi(fileBlocks[i].fileName, "FILE_NAME") == 0)
                            {
                                skip = 1;
                            }
                        }
                        if (patcherState->cleadOption == CLEAD_BELT_ONLY)
                        {
                            if (strcmpi(fileBlocks[i].fileName, "phw_02_lb_0006.pac") == 0)
                            {
                                printColor("\nSkipped - ", YELLOW);printf("phw_02_lb_0006.pac");
                                skip = 1;
                            }
                            if (strcmpi(fileBlocks[i].fileName, "phw_00_lb_0004.pac") == 0)
                            {
                                printColor("\nSkipped - ", YELLOW);printf("phw_00_LB_0004.pac");
                                skip = 1;
                            }
                        }
                    }
                    if (patcherState->booleanValues[CAVARO] == ON)
                    {
                         if (patcherState->cavaroOption != ON)
                         {
                             if (strcmpi(fileBlocks[i].fileName, "FILE_NAME") == 0)
                            {
                                skip = 1;
                            }
                         }
                    }
                    if (patcherState->booleanValues[ECKETT] == ON)
                    {
                        if (strcmpi(fileBlocks[i].fileName, "FILE_NAME") == 0)
                        {
                            skip = 1;
                        }
                    }
                    if (patcherState->booleanValues[CARTIAN] == ON)
                    {
                        if (strcmpi(fileBlocks[i].fileName, "phw_00_lb_0043.pac") == 0)
                        {
                             printColor("\nSkipped - ", YELLOW);printf("phw_00_lb_0043.pac");
                            skip = 1;
                        }
                    }
                    if (patcherState->booleanValues[PAPPILO] == ON)
                    {
                        if (strcmpi(fileBlocks[i].fileName, "FILE_NAME") == 0)
                        {
                            skip = 1;
                        }
                    }
                    if (patcherState->booleanValues[BERN] == ON)
                    {
                        if (patcherState->bernOptions[BELT_ONLY] == ON)
                        {
                            if (strcmpi(fileBlocks[i].fileName, "phw_02_lb_0006.pac") == 0)
                            {
                                printColor("\nSkipped - ", YELLOW);printf("phw_02_lb_0006.pac");
                                skip = 1;
                            }
                        }

                        if (patcherState->bernOptions[REMOVE_SILVER_CHEST] == ON)
                        {
                            if (strcmpi(fileBlocks[i].fileName, "phw_02_sho_0006.pac") == 0)
                            {
                                 printColor("\nSkipped - ", YELLOW);printf("phw_02_SHO_0006.pac");
                                skip = 1;
                            }
                        }
                    }

                    if(skip == 0)
                    {
                        addToPartCutDesc(fileBlocks[i], partcutdesc);
                    }
                }
            }
            if (classAllowed[PEW])
            {
                if (strcmpi(classPrefix,"pew") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PGM])
            {
                if (strcmpi(classPrefix,"pgm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PBW])
            {
                if (strcmpi(classPrefix,"pbw") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PKM])
            {
                if (strcmpi(classPrefix,"pkm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PVW])
            {
                if (strcmpi(classPrefix,"pvw") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PWM])
            {
                if (strcmpi(classPrefix,"pwm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PWW])
            {
                if (strcmpi(classPrefix,"pww") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PHM])
            {
                if (strcmpi(classPrefix,"phm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PNW])
            {
                if (strcmpi(classPrefix,"pnw") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PNM])
            {
                if (strcmpi(classPrefix,"pnm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PDW])
            {
                if (strcmpi(classPrefix,"pdw") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PKWW])
            {
                if (strcmpi(classPrefix,"pkww") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
         }
    }
    writestr("</CutType>\n\n",partcutdesc);
}
