#include "../include/global.h"

// is the variable that contains the 8 bytes that are going to be replaced after each reference byte is found
//int MODDED_BYTES[][2] = {{1,66404},{1,170861},{1,60556},{1,91771}};
//char *MODDED_BYTES[4] = {"\x01\x00\x00\x00\x64\x03\x01\x00","\x01\x00\x00\x00\x6D\x9B\x02\x00","\x01\x00\x00\x00\x8D\xEC\x00\x00","\x01\x00\x00\x00\x7B\x66\x01\x00"};
//                                  NA                                 RU                                   KR                               JP

char* LATEST_MODIFICATIONS_FILE_NAME = "bmir_latest_modifications.bin";
char* PATCHER_STATE_FILE_NAME = "bmir_patcher_state.bin";

int classRestrictions[12] = {0};

    char *starters[][12] =
    {
/*ARMOR*/        {"phw_02_ub_0001.pac","pew_02_ub_0001.pac","pvw_02_ub_0007.pac","pbw_02_ub_0001.pac","pww_03_ub_0003.pac","phm_02_ub_0001.pac","pgm_02_ub_0001.pac","pkww_02_ub_0001.pac","pkm_02_ub_0001.pac","pnw_02_ub_0001.pac","pnm_02_ub_0001.pac","pwm_03_ub_0003.pac"},
/*UNDERWEAR*/    {"phm_00_uw_0001.pac","phw_00_uw_0001.pac","pew_00_uw_0001.pac","pgm_00_uw_0001.pac","pbw_00_uw_0001.pac","pkm_00_uw_0001.pac","pvw_00_uw_0001.pac","pwm_00_uw_0001.pac","pww_00_uw_0001.pac","pnm_00_uw_0001.pac","pnw_00_uw_0001.pac","pkww_00_uw_0001.pac"},
/*LOWERBODY*/    {"phw_02_lb_0001.pac","pew_02_lb_0001.pac","pvw_02_lb_0007.pac","pbw_02_lb_0001.pac","pww_03_lb_0003.pac","phm_02_lb_0001.pac","pgm_02_lb_0001.pac","pkww_02_lb_0001.pac","pkm_02_lb_0001.pac","pnw_02_lb_0001.pac","pnm_02_lb_0001.pac","pwm_03_lb_0003.pac"},
/*GLOVES*/       {"phw_02_hand_0001.pac","pew_02_hand_0001.pac","pvw_02_hand_0007.pac","pbw_02_hand_0001.pac","pww_03_hand_0003.pac","phm_02_hand_0001.pac","pgm_02_hand_0001.pac","pkww_02_hand_0001.pac","pkm_02_hand_0001.pac","pnw_02_hand_0001.pac","pnm_02_hand_0001.pac","pwm_03_hand_0003.pac"},
/*BOOTS*/        {"phw_02_foot_0001.pac","pew_02_foot_0001.pac","pvw_02_foot_0007.pac","pbw_02_foot_0001.pac","pww_03_foot_0003.pac","phm_02_foot_0001.pac","pgm_02_foot_0001.pac","pkww_02_foot_0001.pac","pkm_02_foot_0001.pac","pnw_02_foot_0001.pac","pnm_02_foot_0001.pac","pwm_03_foot_0003.pac"},
/*HELMETS*/      {"","","","","","","","","","","",""},
/*STOCKINGS*/    {"","","","","","","","","","","",""},
/*SORC_WEAPONS*/ {"phw_00_eca_0001.pac","phw_00_eca_0001_in.pac","phw_00_tlm_0001.pac","phw_00_tlm_0001_in.pac","","","","","","","",""},
/*GENDER*/       {"","","","","","","","","","","",""},
/*SHOULDER*/     {"phw_02_sho_0001.pac","","","","","","","","","","",""},
/*CLOAK*/        {"","","","","","","","","","","",""}
    };

     char* starterStockings[] = {"pew_00_lb_0010_dec.dds","pew_00_lb_0010_dm_dec.dds","phw_00_uw_0001_03_dec.dds","phw_00_uw_0001_03_dm_dec.dds", "pvw_00_uw_0001_03_dec.dds","pvw_00_uw_0001_03_dm_dec.dds"};
     char* starterUnderwearTextures[] = {"PEW_99_UB_0001_02.dds","PEW_99_UB_0001_dec.dds","PHW_99_UB_0001_02.dds","PHW_99_UB_0001_dec.dds", "PBW_00_UW_0001_dec.dds","PBW_00_UW_0001.dds","PKW_00_UW_0001.dds","PKW_00_UW_0001_dec.dds"};

    char* nudeTextures[] = {"pew_01_nude_0001.dds","pww_01_nude_0001.dds","pbw_00_nude_0001.dds","phw_01_nude_0001.dds"};
    char* pubicHairFolder[] = {
        "patcher_resources\\texture\\",
        "patcher_resources\\texture\\pubic_hair\\full_bush\\",
        "patcher_resources\\texture\\pubic_hair\\medium_bush\\",
        "patcher_resources\\texture\\pubic_hair\\medium_bush2\\",
        "patcher_resources\\texture\\pubic_hair\\small_bush\\",
        "patcher_resources\\texture\\pubic_hair\\small_bush_2\\",
        "patcher_resources\\texture\\pubic_hair\\thin_landing_strip\\",
        "patcher_resources\\texture\\pubic_hair\\wide_landing_strip\\",
        "patcher_resources\\texture\\pubic_hair\\trimmed\\",
        "patcher_resources\\texture\\pubic_hair\\wider_trimmed\\"};
    /**
    typedef enum {ARMOR,UNDERWEAR,LOWERBODY,GLOVES,BOOTS,HELMETS,STOCKINGS,WEAPONS,GENDER,SHOULDER,CLOAK} PatcherOption;
    typedef enum {ALL,STARTER,KEEP,REGULAR,LIFE_SKILL,PANTIES_ONLY,IN} Restriction;
    **/

    char* panties[] = {
        "pbw_00_lb_0007.pac",
		"pbw_00_lb_0007_dm.pac",
		"pbw_00_lb_0015.pac",
		"pbw_00_lb_0016.pac",
		"pbw_00_lb_0016_dm.pac",
		"pbw_00_lb_0017.pac",
		"pbw_00_lb_0017_dm.pac",
		"pbw_02_lb_0001.pac",
		"pbw_02_lb_0001_dm.pac",
		"pbw_02_lb_0002.pac",
		"pbw_02_lb_0003.pac",
		"pbw_02_lb_0004.pac",
		"pbw_02_lb_0005.pac",
		"pbw_02_lb_0005_dm.pac",
		"pbw_02_lb_0006.pac",
		"pbw_02_lb_0006_dm.pac",
		"pbw_03_lb_0001.pac",
		"pbw_03_lb_0002.pac",
		"pbw_03_lb_0002_dm.pac",
		"pbw_10_lb_0001.pac",
		"pbw_10_lb_0003.pac",
		"pbw_10_lb_0006.pac",
		"pew_00_lb_0006.pac",
        "pew_00_lb_0007.pac",
		"pew_01_lb_0001.pac",
		"pew_01_lb_0001_dm.pac",
		"pew_02_lb_0001.pac",
		"pew_02_lb_0001_dm.pac",
		"pew_02_lb_0002.pac",
		"pew_02_lb_0002_dm.pac",
		"pew_02_lb_0003.pac",
		"pew_02_lb_0003_dm.pac",
		"pew_02_lb_0004.pac",
		"pew_02_lb_0004_dm.pac",
		"pew_03_lb_0002.pac",
		"pew_10_lb_0001.pac",
		"pew_10_lb_0003.pac",
		"pew_10_lb_0006.pac",
		"phw_00_lb_0002.pac",
        "phw_00_lb_0005.pac",
		"phw_00_lb_0030.pac",
		"phw_10_lb_0001.pac",
		"phw_10_lb_0003.pac",
		"phw_10_lb_0006.pac"
        "pkww_10_lb_0001.pac",
		"pkww_10_lb_0003.pac",
		"pkww_bw_lb_0015.pac",
        "pnw_02_lb_0001.pac",
		"pnw_10_lb_0001.pac",
		"pnw_10_lb_0003.pac",
		"pnw_bw_lb_0015.pac",
        "pvw_00_lb_0007.pac",
		"pvw_00_lb_0007_01.pac",
		"pvw_00_lb_0007_01_dm.pac",
		"pvw_00_lb_0007_dm.pac",
		"pvw_00_lb_0058.pac",
		"pvw_02_lb_0002.pac",
		"pvw_02_lb_0003.pac",
		"pvw_03_lb_0001.pac",
		"pvw_10_lb_0001.pac",
		"pvw_10_lb_0003.pac",
        "pww_00_lb_0007.pac",
		"pww_00_lb_0007_01.pac",
		"pww_00_lb_0007_01_dm.pac",
		"pww_00_lb_0007_dm.pac",
		"pww_10_lb_0001.pac",
		"pww_10_lb_0003.pac"
    };

    char* pants[] = {
        "pew_03_lb_0001.pac",
        "pew_03_lb_0003.pac",
        "phw_00_lb_0007.pac",
        "phw_00_lb_0010.pac",
        "phw_00_lb_0049.pac",
        "phw_00_lb_0049_dm.pac",
        "phw_02_lb_0001.pac",
        "phw_02_lb_0002.pac",
        "phw_02_lb_0003.pac",
        "phw_02_lb_0004.pac",
        "phw_03_lb_0001.pac",
        "phw_03_lb_0002.pac",
        "phw_03_lb_0003.pac",
        "phw_20_lb_0003.pac",
        "phw_20_lb_0004.pac",
        "pkww_00_lb_0012.pac",
        "pkww_02_lb_0001.pac",
        "pkww_02_lb_0002.pac",
        "pkww_02_lb_0003.pac",
        "pkww_02_lb_0004.pac",
        "pkww_02_lb_0005.pac",
        "pkww_03_lb_0003.pac",
        "pnw_02_lb_0002.pac",
        "pnw_02_lb_0002_dm.pac",
        "pnw_02_lb_0003.pac",
        "pnw_02_lb_0003_dm.pac",
        "pnw_02_lb_0004.pac",
        "pnw_02_lb_0004_dm.pac",
        "pnw_03_lb_0001.pac",
        "pnw_03_lb_0001_dm.pac",
        "pnw_03_lb_0002.pac",
        "pnw_03_lb_0002_dm.pac",
        "pvw_02_lb_0001.pac",
        "pvw_02_lb_0007.pac",
        "pww_00_lb_0001.pac",
        "pww_02_lb_0001.pac",
        "pww_02_lb_0002.pac",
        "pww_02_lb_0003.pac",
        "pww_03_lb_0001.pac",
        "pww_03_lb_0002.pac",
        "pww_03_lb_0003.pac",
        "pww_03_lb_0004.pac",
    };

    char * stockings[] = {
    "phw_00_uw_0001_03_dec.dds"
    "pew_00_lb_0010_dec.dds"
    "pew_00_uw_0011_02_dec.dds",
    "pew_00_uw_0014_01_dec.dds",
    "pew_00_uw_0030_03_dec.dds",
    "pew_00_uw_0031_dec.dds",
    "pew_00_uw_0035_dec.dds",
    "pew_99_ub_0008_01_dec.dds",
    "phw_00_uw_0002_03_dec.dds",
    "phw_00_uw_0003_03_dec.dds",
    "phw_00_uw_0004_03_dec.dds",
    "phw_00_uw_0005_03_dec.dds",
    "phw_00_uw_0006_03_dec.dds",
    "phw_00_uw_0007_03_dec.dds",
    "phw_00_uw_0011_02_dec.dds",
    "phw_00_uw_0031_dec.dds",
    "phw_00_uw_0032_02_dec.dds",
    "pvw_00_uw_0001_03_dec.dds"
    };


